#ifndef __FONTHANDLER_HP
#define __FONTHANDLER_HP


/******************************************************************************/
/*																	    								*/
/*											FontHandler.h											*/	
/*																										*/
/*																										*/
/*		This header file contains the function prototypes for the Font library	*/
/*		routines defined in the FontHandler.cp file.										*/
/*																										*/
/******************************************************************************/
/*																										*/
/*		(c) 1995 by Magnet Interactive Studios, inc. All rights reserved.			*/
/*																										*/
/******************************************************************************/
/*																										*/
/*		Change History:																			*/
/*																										*/						
/*			<1>	1/16/95		Glenn Ortner													*/	
/*																										*/
/*									Started today.  Placed function prototypes here		*/
/*									for the FontHandler.cp file.								*/
/*																										*/
/******************************************************************************/




/**************************  ANSI AND 3DO INCLUDES  ***************************/

#include <TextLib.h>



/****************************  C_FontHandler Class  ***************************/
/*																										*/
/*																										*/
/*																										*/
/******************************************************************************/

class	C_FontHandler
{
	
	unsigned numTextCels;
	FontDescriptor *gFontDescPtr;		/* Holds the ant-aliased font to use */
	TextCel *gTextCelPtr1;				/* Holds the text cel and other data */
	TextCel *gTextCelPtr2;				/* Holds the text cel and other data */
	TextCel *gTextCelPtr3;				/* Holds the text cel and other data */
	TextCel *gTextCelPtr4;				/* Holds the text cel and other data */
	TextCel *gTextCelPtr5;				/* Holds the text cel and other data */
	TextCel *gTextCelPtr6;				/* Holds the text cel and other data */
	TextCel *gTextCelPtr7;				/* Holds the text cel and other data */
	TextCel *gTextCelPtr8;				/* Holds the text cel and other data */
	TextCel *gTextCelPtr9;				/* Holds the text cel and other data */
	TextCel *gTextCelPtr10;				/* Holds the text cel and other data */
	
	
	/* Private methods below */

	void AddColorToText(uint32 redBgColor, uint32 greenBgColor,
							  uint32 blueBgColor, uint32 redFgColor,
							  uint32 greenFgColor, uint32 blueFgColor,
							  int textCelID);
	

	public:	

		C_FontHandler();				/* The class constructor */
		~C_FontHandler();				/* The class destructor */
		
		int CreateCelFromFont(char *fontFileName);
		
		int CreateCelFromFont(void);
		
		CCB* PlaceTextInCel(char *textContent, uint32 redBgColor,
								  uint32 greenBgColor, uint32 blueBgColor, 
		 					     uint32 redFgColor, uint32 greenFgColor, 
		 					  	  uint32 blueFgColor, unsigned textCelID);
							
		CCB* PlaceTextInCel(char *textContent, unsigned textCelID);
								  		
}; 	/* End of Class C_FontHandler */


#endif	/* __FONTHANDLER_HP */




/***********************************  EOF  ************************************/






