/****************************************************************************************/
/*                                    ANIMATION.H                                       */
/****************************************************************************************/
/*          (c) 1995 by Magnet Interactive Studios, inc. All rights reserved.           */
/****************************************************************************************/
/*  Revision History:                                                                   */
/*  v5.6	    5/5/95	 Icebreaker Golden Master version. By Andrew Looney.			       */
/****************************************************************************************/

/****************************************************************************************/

class anim_source
{
	public:
		ANIM			*anim_pointer;

		bool			LoadArtwork (char *filename);		
		void			ShutdownForExit (void);
};

/****************************************************************************************/

class anim_user
{
	private:
		anim_source	*anim_source_pointer;
		CCB			*next_frame_ccb;
		int32			anim_frame_rate;
		bool			dormant;
		
	public:
		CCB			*current_frame_ccb;
		int32			current_frame_number;

		void			InitializeAnim (anim_source *original, int32 frame_rate);		
		void 			ChangeArt (anim_source *original);
		void			PositionAnim (int32 x_position, int32 y_position);
		void			AdvanceFrame (void);
		void			RefetchFrame (void);
		void			DisplayFrame (void);
		void			Restart (void);
		bool			AnimComplete (void);
		bool			AnimCued (void);
		bool 			AnimOnGivenFrame(int32 frame);
		void			MoveAnim (int32 x_change, int32 y_change);
		void			ShutdownForRestart (void);
};

/***************************************** EOF ******************************************/
