/****************************************************************************************/
/*                                    DUDEMEYER.H                                       */
/****************************************************************************************/
/*          (c) 1995 by Magnet Interactive Studios, inc. All rights reserved.           */
/****************************************************************************************/
/*  Revision History:                                                                   */
/*  v5.6	    5/5/95	 Icebreaker Golden Master version. By Andrew Looney.			       */
/****************************************************************************************/

#define DUDEMEYER_WEST        "$boot/IceFiles/DudemeyerArt/dm5.cel"
#define DUDEMEYER_EAST        "$boot/IceFiles/DudemeyerArt/dm1.cel"
#define DUDEMEYER_SOUTH       "$boot/IceFiles/DudemeyerArt/dm3.cel"
#define DUDEMEYER_NORTH       "$boot/IceFiles/DudemeyerArt/dm7.cel"
#define DUDEMEYER_NE          "$boot/IceFiles/DudemeyerArt/dm8.cel"
#define DUDEMEYER_NW          "$boot/IceFiles/DudemeyerArt/dm6.cel"
#define DUDEMEYER_SE          "$boot/IceFiles/DudemeyerArt/dm2.cel"
#define DUDEMEYER_SW          "$boot/IceFiles/DudemeyerArt/dm4.cel"

#define DUDESHOOTS_WEST       "$boot/IceFiles/DudemeyerArt/dsw.anim"
#define DUDESHOOTS_EAST       "$boot/IceFiles/DudemeyerArt/dse.anim"
#define DUDESHOOTS_SOUTH      "$boot/IceFiles/DudemeyerArt/dss.anim"
#define DUDESHOOTS_NORTH      "$boot/IceFiles/DudemeyerArt/dsn.anim"
#define DUDESHOOTS_NE         "$boot/IceFiles/DudemeyerArt/dsne.anim"
#define DUDESHOOTS_NW         "$boot/IceFiles/DudemeyerArt/dsnw.anim"
#define DUDESHOOTS_SE         "$boot/IceFiles/DudemeyerArt/dsse.anim"
#define DUDESHOOTS_SW         "$boot/IceFiles/DudemeyerArt/dssw.anim"

#define DUDEDEATH_WEST        "$boot/IceFiles/DudemeyerArt/ddw.anim"
#define DUDEDEATH_EAST        "$boot/IceFiles/DudemeyerArt/dde.anim"
#define DUDEDEATH_SOUTH       "$boot/IceFiles/DudemeyerArt/dds.anim"
#define DUDEDEATH_NORTH       "$boot/IceFiles/DudemeyerArt/ddn.anim"
#define DUDEDEATH_NE          "$boot/IceFiles/DudemeyerArt/ddne.anim"
#define DUDEDEATH_NW          "$boot/IceFiles/DudemeyerArt/ddnw.anim"
#define DUDEDEATH_SE          "$boot/IceFiles/DudemeyerArt/ddse.anim"
#define DUDEDEATH_SW          "$boot/IceFiles/DudemeyerArt/ddsw.anim"

#define DUDEMEYER_ANGEL		   "$boot/IceFiles/DudemeyerArt/dmangel.anim"
#define FELL_INTO_PIT_ANIM    "$boot/IceFiles/DudemeyerArt/dmpit.anim"
#define DEATH_BY_LAVA_ANIM    "$boot/IceFiles/DudemeyerArt/dmlava.anim"
#define DEATH_BY_SLIME_ANIM   "$boot/IceFiles/DudemeyerArt/dmslime.anim"
#define SHOT_BY_FIREBALL_ANIM "$boot/IceFiles/DudemeyerArt/dmzap.anim"

/***** ice handling symbols *****/

#define HORZ_SLIPPERYNESS  11
#define VERT_SLIPPERYNESS  8
#define OFF_THE_ICE        0
#define STATIONARY         1
#define ACCELERATING       2
#define DECCELERATING      3
#define FULL_THROTTLE      4
#define SKIDDING           5

/***** visual state values *****/

#define NORMAL_VIEW			0
#define SHOOTING_VIEW		1
#define ACCELERATING_VIEW	2
#define BRAKING_VIEW			3

/****************************************************************************************/

class dudemeyer 
{
	private:
		CCB   		 *dudemeyer_views[8];
		anim_source	 shooting_sources[8];
		anim_user	 dudemeyer_shooting[8];
		int32 		 col_detect_x[8];
		int32 		 col_detect_y[8];
		int32			 ice_delay_x;
		int32			 ice_delay_y;
		
	public:
		anim_source	 dudemeyer_deaths[8];
		anim_source	 pitfall_death;
		anim_source	 lava_death;
		anim_source	 slime_death;
		anim_source	 got_shot_death;
		anim_source	 angel;
		CCB			 *dudemeyer_cel;
		solid_object *dudemeyer_object;
		int32			 direction;
		int32 		 old_direction;
		int32	 		 vert_speed;
		int32			 horz_speed;
		int32			 ice_movement_state;
		int32			 old_ice_direction;
		int32			 visual_state;

		bool  		 LoadArtwork (void);
		void  		 InitializeDudemeyer (void);		
		void  		 MoveDudemeyer (int32 x_change, int32 y_change);
		bool  		 ChangeDirection (void);
		bool  		 Obstructed (bool deal_with_death);		
		void  		 Vanish (int percentage);
		void 			 IceMovementAdjustments(int32 &x_change,int32 &y_change,uint32 action);
		void 			 UpdateView (int32 new_mode);
		void 			 RestoreView (void);
		void  		 ShutdownForExit (void);
};

/***************************************** EOF ******************************************/
