/****************************************************************************************/
/*                                     SEEKER.H                                         */
/****************************************************************************************/
/*          (c) 1995 by Magnet Interactive Studios, inc. All rights reserved.           */
/****************************************************************************************/
/*  Revision History:                                                                   */
/*  v5.6	    5/5/95	 Icebreaker Golden Master version. By Andrew Looney.			       */
/*  v6.1	   8/21/95	 Began making changes for Icebreaker Two. By Andrew Looney.		    */
/****************************************************************************************/

/***** yellow seeker art & animations *****/

#define YELLOW_WALK_EAST      "$boot/IceFiles/SeekerArt/yellow/ye.anim"
#define YELLOW_WALK_NORTH     "$boot/IceFiles/SeekerArt/yellow/yn.anim"
#define YELLOW_WALK_NE        "$boot/IceFiles/SeekerArt/yellow/yne.anim"
#define YELLOW_WALK_NW        "$boot/IceFiles/SeekerArt/yellow/ynw.anim"
#define YELLOW_WALK_SOUTH     "$boot/IceFiles/SeekerArt/yellow/ys.anim"
#define YELLOW_WALK_WEST      "$boot/IceFiles/SeekerArt/yellow/yw.anim"
#define YELLOW_WALK_SW        "$boot/IceFiles/SeekerArt/yellow/ysw.anim"
#define YELLOW_WALK_SE        "$boot/IceFiles/SeekerArt/yellow/yse.anim"
#define YELLOW_DEATH_ANIM     "$boot/IceFiles/SeekerArt/yellow/yd.anim"
#define YELLOW_PIT_ANIM       "$boot/IceFiles/SeekerArt/yellow/ydp.anim"
#define YELLOW_LAVA_ANIM      "$boot/IceFiles/SeekerArt/yellow/ydl.anim"
#define YELLOW_PIECE_FILE     "$boot/IceFiles/SeekerArt/yellow/yellow.cel"

/***** light blue seeker art & animations *****/

#define LTBLUE_WALK_EAST      "$boot/IceFiles/SeekerArt/lightblue/lbe.anim"
#define LTBLUE_WALK_NORTH     "$boot/IceFiles/SeekerArt/lightblue/lbn.anim"
#define LTBLUE_WALK_NE        "$boot/IceFiles/SeekerArt/lightblue/lbne.anim"
#define LTBLUE_WALK_NW        "$boot/IceFiles/SeekerArt/lightblue/lbnw.anim"
#define LTBLUE_WALK_SOUTH     "$boot/IceFiles/SeekerArt/lightblue/lbs.anim"
#define LTBLUE_WALK_WEST      "$boot/IceFiles/SeekerArt/lightblue/lbw.anim"
#define LTBLUE_WALK_SW        "$boot/IceFiles/SeekerArt/lightblue/lbsw.anim"
#define LTBLUE_WALK_SE        "$boot/IceFiles/SeekerArt/lightblue/lbse.anim"
#define LTBLUE_DEATH_ANIM     "$boot/IceFiles/SeekerArt/lightblue/lbd.anim"
#define LTBLUE_PIT_ANIM       "$boot/IceFiles/SeekerArt/lightblue/lbdp.anim"
#define LTBLUE_LAVA_ANIM      "$boot/IceFiles/SeekerArt/lightblue/lbdl.anim"
#define LTBLUE_PIECE_FILE     "$boot/IceFiles/SeekerArt/lightblue/ltblue.cel"

/***** pink seeker art & animations *****/

#define PINK_WALK_EAST      	"$boot/IceFiles/SeekerArt/pink/pe.anim"
#define PINK_WALK_NORTH     	"$boot/IceFiles/SeekerArt/pink/pn.anim"
#define PINK_WALK_NE        	"$boot/IceFiles/SeekerArt/pink/pne.anim"
#define PINK_WALK_NW        	"$boot/IceFiles/SeekerArt/pink/pnw.anim"
#define PINK_WALK_SOUTH     	"$boot/IceFiles/SeekerArt/pink/ps.anim"
#define PINK_WALK_WEST      	"$boot/IceFiles/SeekerArt/pink/pw.anim"
#define PINK_WALK_SW        	"$boot/IceFiles/SeekerArt/pink/psw.anim"
#define PINK_WALK_SE        	"$boot/IceFiles/SeekerArt/pink/pse.anim"
#define PINK_DEATH_ANIM       "$boot/IceFiles/SeekerArt/pink/pd.anim"
#define PINK_PIT_ANIM         "$boot/IceFiles/SeekerArt/pink/pdp.anim"
#define PINK_LAVA_ANIM        "$boot/IceFiles/SeekerArt/pink/pdl.anim"
#define PINK_PIECE_FILE       "$boot/IceFiles/SeekerArt/pink/pink.cel"

/***** lime seeker art & animations *****/

#define LIME_WALK_EAST      	"$boot/IceFiles/SeekerArt/lime/le.anim"
#define LIME_WALK_NORTH     	"$boot/IceFiles/SeekerArt/lime/ln.anim"
#define LIME_WALK_NE        	"$boot/IceFiles/SeekerArt/lime/lne.anim"
#define LIME_WALK_NW        	"$boot/IceFiles/SeekerArt/lime/lnw.anim"
#define LIME_WALK_SOUTH     	"$boot/IceFiles/SeekerArt/lime/ls.anim"
#define LIME_WALK_WEST      	"$boot/IceFiles/SeekerArt/lime/lw.anim"
#define LIME_WALK_SW        	"$boot/IceFiles/SeekerArt/lime/lsw.anim"
#define LIME_WALK_SE        	"$boot/IceFiles/SeekerArt/lime/lse.anim"
#define LIME_DEATH_E		      "$boot/IceFiles/SeekerArt/lime/lde.anim"
#define LIME_DEATH_N		      "$boot/IceFiles/SeekerArt/lime/ldn.anim"
#define LIME_DEATH_S		      "$boot/IceFiles/SeekerArt/lime/lds.anim"
#define LIME_DEATH_W		      "$boot/IceFiles/SeekerArt/lime/ldw.anim"
#define LIME_PIT_ANIM         "$boot/IceFiles/SeekerArt/lime/ldp.anim"
#define LIME_LAVA_ANIM        "$boot/IceFiles/SeekerArt/lime/ldl.anim"
#define LIME_PIECE_FILE       "$boot/IceFiles/SeekerArt/lime/lime.cel"
#define LIME_STILL		      "$boot/IceFiles/SeekerArt/lime/lrest.anim"

/***** pac-mid seeker art & animations *****/

#define PACMID_WALK_EAST      "$boot/IceFiles/SeekerArt/pacmid/pace.anim"
#define PACMID_WALK_NORTH     "$boot/IceFiles/SeekerArt/pacmid/pacn.anim"
#define PACMID_WALK_NE        "$boot/IceFiles/SeekerArt/pacmid/pacne.anim"
#define PACMID_WALK_NW        "$boot/IceFiles/SeekerArt/pacmid/pacnw.anim"
#define PACMID_WALK_SOUTH     "$boot/IceFiles/SeekerArt/pacmid/pacs.anim"
#define PACMID_WALK_WEST      "$boot/IceFiles/SeekerArt/pacmid/pacw.anim"
#define PACMID_WALK_SW        "$boot/IceFiles/SeekerArt/pacmid/pacsw.anim"
#define PACMID_WALK_SE        "$boot/IceFiles/SeekerArt/pacmid/pacse.anim"
#define PACMID_DEATH_E		   "$boot/IceFiles/SeekerArt/pacmid/pacde.anim"
#define PACMID_DEATH_N		   "$boot/IceFiles/SeekerArt/pacmid/pacdn.anim"
#define PACMID_DEATH_S		   "$boot/IceFiles/SeekerArt/pacmid/pacds.anim"
#define PACMID_DEATH_W		   "$boot/IceFiles/SeekerArt/pacmid/pacdw.anim"
#define PACMID_PIT_ANIM       "$boot/IceFiles/SeekerArt/pacmid/pacdp.anim"
#define PACMID_LAVA_ANIM      "$boot/IceFiles/SeekerArt/pacmid/pacdl.anim"
#define PACMID_PIECE_FILE     "$boot/IceFiles/SeekerArt/pacmid/pac.cel"
#define PACMID_STILL     		"$boot/IceFiles/SeekerArt/pacmid/pacrest.anim"

/***** walking egg art & animations *****/

#define EGG_WALK_EAST      	"$boot/IceFiles/SeekerArt/egg/ege.anim"
#define EGG_WALK_NORTH     	"$boot/IceFiles/SeekerArt/egg/egn.anim"
#define EGG_WALK_NE        	"$boot/IceFiles/SeekerArt/egg/egne.anim"
#define EGG_WALK_NW        	"$boot/IceFiles/SeekerArt/egg/egnw.anim"
#define EGG_WALK_SOUTH     	"$boot/IceFiles/SeekerArt/egg/egs.anim"
#define EGG_WALK_WEST      	"$boot/IceFiles/SeekerArt/egg/egw.anim"
#define EGG_WALK_SW        	"$boot/IceFiles/SeekerArt/egg/egsw.anim"
#define EGG_WALK_SE        	"$boot/IceFiles/SeekerArt/egg/egse.anim"
#define EGG_DEATH_E		   	"$boot/IceFiles/SeekerArt/egg/egde.anim"
#define EGG_DEATH_N		   	"$boot/IceFiles/SeekerArt/egg/egdn.anim"
#define EGG_DEATH_S		   	"$boot/IceFiles/SeekerArt/egg/egds.anim"
#define EGG_DEATH_W		   	"$boot/IceFiles/SeekerArt/egg/egdw.anim"
#define EGG_PIT_ANIM       	"$boot/IceFiles/SeekerArt/egg/egdp.anim"
#define EGG_LAVA_ANIM      	"$boot/IceFiles/SeekerArt/egg/egdl.anim"
#define EGG_WAIT_ANIM      	"$boot/IceFiles/SeekerArt/egg/egrest.anim"
#define EGG_PIECE_FILE     	"$boot/IceFiles/SeekerArt/egg/egg.cel"

/***** chameleon seeker art & animations *****/

#define CHAM_WAKEUP_ANIM		"$boot/IceFiles/SeekerArt/chameleon/greentolime.anim"
#define CHAM_DEATH_E		      "$boot/IceFiles/SeekerArt/chameleon/cde.anim"
#define CHAM_DEATH_N		      "$boot/IceFiles/SeekerArt/chameleon/cdn.anim"
#define CHAM_DEATH_S		      "$boot/IceFiles/SeekerArt/chameleon/cds.anim"
#define CHAM_DEATH_W		      "$boot/IceFiles/SeekerArt/chameleon/cdw.anim"

/***** redcoat seeker art & animations *****/

#define REDCOAT_WAKEUP_ANIM	"$boot/IceFiles/SeekerArt/redcoat/redtolurker.anim"
#define REDCOAT_DEATH_E		   "$boot/IceFiles/SeekerArt/redcoat/rcde.anim"
#define REDCOAT_DEATH_N		   "$boot/IceFiles/SeekerArt/redcoat/rcdn.anim"
#define REDCOAT_DEATH_S		   "$boot/IceFiles/SeekerArt/redcoat/rcds.anim"
#define REDCOAT_DEATH_W		   "$boot/IceFiles/SeekerArt/redcoat/rcdw.anim"

/***** bummer seeker art & animations *****/

#define BUMMER_WAKEUP_ANIM		"$boot/IceFiles/SeekerArt/bummer/bluetocyan.anim"
#define BUMMER_DEATH_ANIM		"$boot/IceFiles/SeekerArt/bummer/bud.anim"

/***** zombie art & animations *****/

#define ZOMBIE_BIRTH_ANIM     "$boot/IceFiles/SeekerArt/zombie/zbirth.anim"
#define ZOMBIE_SHRAPNEL_ANIM  "$boot/IceFiles/SeekerArt/zombie/zshrap.anim"
#define ZOMBIE_DEATH_ANIM     "$boot/IceFiles/SeekerArt/zombie/zd.anim"

#define ZOMBIE1_WALK_EAST     "$boot/IceFiles/SeekerArt/zombie/z1e.anim"
#define ZOMBIE1_WALK_NORTH    "$boot/IceFiles/SeekerArt/zombie/z1n.anim"
#define ZOMBIE1_WALK_NE       "$boot/IceFiles/SeekerArt/zombie/z1ne.anim"
#define ZOMBIE1_WALK_NW       "$boot/IceFiles/SeekerArt/zombie/z1nw.anim"
#define ZOMBIE1_WALK_SOUTH    "$boot/IceFiles/SeekerArt/zombie/z1s.anim"
#define ZOMBIE1_WALK_WEST     "$boot/IceFiles/SeekerArt/zombie/z1w.anim"
#define ZOMBIE1_WALK_SW       "$boot/IceFiles/SeekerArt/zombie/z1sw.anim"
#define ZOMBIE1_WALK_SE       "$boot/IceFiles/SeekerArt/zombie/z1se.anim"
#define ZOMBIE1_PIT_ANIM      "$boot/IceFiles/SeekerArt/zombie/z1dp.anim"
#define ZOMBIE1_LAVA_ANIM     "$boot/IceFiles/SeekerArt/zombie/z1dl.anim"

#define ZOMBIE2_WALK_EAST     "$boot/IceFiles/SeekerArt/zombie/z2e.anim"
#define ZOMBIE2_WALK_NORTH    "$boot/IceFiles/SeekerArt/zombie/z2n.anim"
#define ZOMBIE2_WALK_NE       "$boot/IceFiles/SeekerArt/zombie/z2ne.anim"
#define ZOMBIE2_WALK_NW       "$boot/IceFiles/SeekerArt/zombie/z2nw.anim"
#define ZOMBIE2_WALK_SOUTH    "$boot/IceFiles/SeekerArt/zombie/z2s.anim"
#define ZOMBIE2_WALK_WEST     "$boot/IceFiles/SeekerArt/zombie/z2w.anim"
#define ZOMBIE2_WALK_SW       "$boot/IceFiles/SeekerArt/zombie/z2sw.anim"
#define ZOMBIE2_WALK_SE       "$boot/IceFiles/SeekerArt/zombie/z2se.anim"
#define ZOMBIE2_PIT_ANIM      "$boot/IceFiles/SeekerArt/zombie/z2dp.anim"
#define ZOMBIE2_LAVA_ANIM     "$boot/IceFiles/SeekerArt/zombie/z2dl.anim"

#define ZOMBIE3_WALK_EAST     "$boot/IceFiles/SeekerArt/zombie/z3e.anim"
#define ZOMBIE3_WALK_NORTH    "$boot/IceFiles/SeekerArt/zombie/z3n.anim"
#define ZOMBIE3_WALK_NE       "$boot/IceFiles/SeekerArt/zombie/z3ne.anim"
#define ZOMBIE3_WALK_NW       "$boot/IceFiles/SeekerArt/zombie/z3nw.anim"
#define ZOMBIE3_WALK_SOUTH    "$boot/IceFiles/SeekerArt/zombie/z3s.anim"
#define ZOMBIE3_WALK_WEST     "$boot/IceFiles/SeekerArt/zombie/z3w.anim"
#define ZOMBIE3_WALK_SW       "$boot/IceFiles/SeekerArt/zombie/z3sw.anim"
#define ZOMBIE3_WALK_SE       "$boot/IceFiles/SeekerArt/zombie/z3se.anim"
#define ZOMBIE3_PIT_ANIM      "$boot/IceFiles/SeekerArt/zombie/z3dp.anim"
#define ZOMBIE3_LAVA_ANIM     "$boot/IceFiles/SeekerArt/zombie/z3dl.anim"

/***** lurker art & animations *****/

#define LURKER_WALK_EAST      "$boot/IceFiles/SeekerArt/lurker/lke.anim"
#define LURKER_WALK_NORTH     "$boot/IceFiles/SeekerArt/lurker/lkn.anim"
#define LURKER_WALK_NE        "$boot/IceFiles/SeekerArt/lurker/lkne.anim"
#define LURKER_WALK_NW        "$boot/IceFiles/SeekerArt/lurker/lknw.anim"
#define LURKER_WALK_SOUTH     "$boot/IceFiles/SeekerArt/lurker/lks.anim"
#define LURKER_WALK_WEST      "$boot/IceFiles/SeekerArt/lurker/lkw.anim"
#define LURKER_WALK_SW        "$boot/IceFiles/SeekerArt/lurker/lksw.anim"
#define LURKER_WALK_SE        "$boot/IceFiles/SeekerArt/lurker/lkse.anim"
#define LURKER_DEATH_E		   "$boot/IceFiles/SeekerArt/lurker/lkde.anim"
#define LURKER_DEATH_N		   "$boot/IceFiles/SeekerArt/lurker/lkdn.anim"
#define LURKER_DEATH_S		   "$boot/IceFiles/SeekerArt/lurker/lkds.anim"
#define LURKER_DEATH_W		   "$boot/IceFiles/SeekerArt/lurker/lkdw.anim"
#define LURKER_PIT_ANIM       "$boot/IceFiles/SeekerArt/lurker/lkdp.anim"
#define LURKER_LAVA_ANIM      "$boot/IceFiles/SeekerArt/lurker/lkdl.anim"
#define LURKER_WAIT_ANIM      "$boot/IceFiles/SeekerArt/lurker/lkrest.anim"
#define LURKER_PIECE_FILE     "$boot/IceFiles/SeekerArt/lurker/lurker.cel"

/***** meany art & animations *****/

#define MEANY_WALK_E_W_N_S   "$boot/IceFiles/SeekerArt/meany/mewns.anim"
#define MEANY_WALK_NE_SW     "$boot/IceFiles/SeekerArt/meany/mnesw.anim"
#define MEANY_WALK_SE_NW     "$boot/IceFiles/SeekerArt/meany/msenw.anim"
#define MEANY_PIT_ANIM       "$boot/IceFiles/SeekerArt/meany/mdp.anim"
#define MEANY_LAVA_ANIM      "$boot/IceFiles/SeekerArt/meany/mdl.anim"
#define MEANY_SPLIT_ANIM     "$boot/IceFiles/SeekerArt/meany/m2n.anim"
#define MEANY_STASIS_ANIM    "$boot/IceFiles/SeekerArt/meany/m2nloop.anim"
#define MEANY_SPLIT_E_ANIM   "$boot/IceFiles/SeekerArt/meany/m2ne.anim"
#define MEANY_SPLIT_W_ANIM   "$boot/IceFiles/SeekerArt/meany/m2nw.anim"
#define MEANY_SPLIT_N_ANIM   "$boot/IceFiles/SeekerArt/meany/m2nn.anim"
#define MEANY_SPLIT_S_ANIM   "$boot/IceFiles/SeekerArt/meany/m2ns.anim"

/***** nasty art & animations *****/

#define NASTY_WALK_E_W_N_S   "$boot/IceFiles/SeekerArt/nasty/newns.anim"
#define NASTY_WALK_NE_SW     "$boot/IceFiles/SeekerArt/nasty/nnesw.anim"
#define NASTY_WALK_SE_NW     "$boot/IceFiles/SeekerArt/nasty/nsenw.anim"
#define NASTY_PIT_ANIM       "$boot/IceFiles/SeekerArt/nasty/ndp.anim"
#define NASTY_LAVA_ANIM      "$boot/IceFiles/SeekerArt/nasty/ndl.anim"
#define NASTY_SPLIT_ANIM     "$boot/IceFiles/SeekerArt/nasty/n2g.anim"
#define NASTY_STASIS_ANIM    "$boot/IceFiles/SeekerArt/nasty/n2gloop.anim"
#define NASTY_SPLIT_E_ANIM   "$boot/IceFiles/SeekerArt/nasty/n2ge.anim"
#define NASTY_SPLIT_W_ANIM   "$boot/IceFiles/SeekerArt/nasty/n2gw.anim"
#define NASTY_SPLIT_N_ANIM   "$boot/IceFiles/SeekerArt/nasty/n2gn.anim"
#define NASTY_SPLIT_S_ANIM   "$boot/IceFiles/SeekerArt/nasty/n2gs.anim"

/***** grumpy art & animations *****/

#define GRUMPY_WALK_E_W_N_S  "$boot/IceFiles/SeekerArt/grumpy/gewns.anim"
#define GRUMPY_WALK_NE_SW    "$boot/IceFiles/SeekerArt/grumpy/gnesw.anim"
#define GRUMPY_WALK_SE_NW    "$boot/IceFiles/SeekerArt/grumpy/gsenw.anim"
#define GRUMPY_DEATH_ANIM    "$boot/IceFiles/SeekerArt/grumpy/gd.anim"
#define GRUMPY_PIT_ANIM      "$boot/IceFiles/SeekerArt/grumpy/gdp.anim"
#define GRUMPY_LAVA_ANIM     "$boot/IceFiles/SeekerArt/grumpy/gdl.anim"

/***** juggernaut art & animations *****/

#define JUGGERNAUT_WALK_EAST  "$boot/IceFiles/SeekerArt/juggernaut/je.anim"
#define JUGGERNAUT_WALK_NORTH "$boot/IceFiles/SeekerArt/juggernaut/jn.anim"
#define JUGGERNAUT_WALK_NE    "$boot/IceFiles/SeekerArt/juggernaut/jne.anim"
#define JUGGERNAUT_WALK_NW    "$boot/IceFiles/SeekerArt/juggernaut/jnw.anim"
#define JUGGERNAUT_WALK_SOUTH "$boot/IceFiles/SeekerArt/juggernaut/js.anim"
#define JUGGERNAUT_WALK_WEST  "$boot/IceFiles/SeekerArt/juggernaut/jw.anim"
#define JUGGERNAUT_WALK_SW    "$boot/IceFiles/SeekerArt/juggernaut/jsw.anim"
#define JUGGERNAUT_WALK_SE    "$boot/IceFiles/SeekerArt/juggernaut/jse.anim"
#define JUGGERNAUT_PIT_ANIM   "$boot/IceFiles/SeekerArt/juggernaut/jdp.anim"
#define JUGGERNAUT_LAVA_ANIM  "$boot/IceFiles/SeekerArt/juggernaut/jdl.anim"
#define JUGGERNAUT_DEATH_ANIM "$boot/IceFiles/SeekerArt/juggernaut/jd.anim"

/***** psycho art & animations *****/

#define PSYCHO_WALK_EAST  		"$boot/IceFiles/SeekerArt/psycho/xoe.anim"
#define PSYCHO_WALK_NORTH 		"$boot/IceFiles/SeekerArt/psycho/xon.anim"
#define PSYCHO_WALK_NE    		"$boot/IceFiles/SeekerArt/psycho/xone.anim"
#define PSYCHO_WALK_NW    		"$boot/IceFiles/SeekerArt/psycho/xonw.anim"
#define PSYCHO_WALK_SOUTH 		"$boot/IceFiles/SeekerArt/psycho/xos.anim"
#define PSYCHO_WALK_WEST  		"$boot/IceFiles/SeekerArt/psycho/xow.anim"
#define PSYCHO_WALK_SW    		"$boot/IceFiles/SeekerArt/psycho/xosw.anim"
#define PSYCHO_WALK_SE    		"$boot/IceFiles/SeekerArt/psycho/xose.anim"
#define PSYCHO_PIT_ANIM   		"$boot/IceFiles/SeekerArt/psycho/xodp.anim"
#define PSYCHO_LAVA_ANIM  		"$boot/IceFiles/SeekerArt/psycho/xodl.anim"
#define PSYCHO_STILL_ANIM  	"$boot/IceFiles/SeekerArt/psycho/xostill.anim"

/***** universal seeker art & animations *****/

#define SEEKER_BEAM_IN_1		"$boot/IceFiles/SeekerArt/Beamins/beamin1.anim"
#define SEEKER_BEAM_IN_2		"$boot/IceFiles/SeekerArt/Beamins/beamin2.anim"

/***** hazard avoidance movement states *****/

#define NORMAL_MOVEMENT 0
#define PRIME_DETOUR    1
#define ALT_DETOUR      2
#define HOUDINI_MODE    3

/***** lurker delay settings *****/

#define LURKER_SLEEP_PHASE 24
#define LURKER_AWAKE_PHASE 36

/****************************************************************************************/

typedef struct dude
{
	int32				breed;
	anim_user		walk_anim[8];
	anim_user		stumbling;
	anim_user		beamin;
	solid_object	*solids_entry;
	int32				health;
	int32				direction;
	int32				horz_speed;
	int32				vert_speed;
	int32				home_row;
	int32				home_column;
	int32				home_offset;
	bool				avoid_hazards;
	bool				avoid_obstacles;
	int32				obstacle_detour_axis;
	int32				obstacle_detour_direction;
	int32				old_obstacle_detour_axis;
	int32				hazard_detour_axis;
	int32				hazard_detour_direction;
	int32				alternate_hazard_direction;
	int32				move_status;
	int32				move_counter;
	int32				stranded_counter;
	int32				immobile_counter;
	int32				reversal_counter;
	int32				previous_x;
	int32				previous_y;
	int32 			bogged_down_in_swamp;
	int32				special;						/* The use of this field is breed-specific. */
	anim_user		special_anim;				/* The use of this field is breed-specific. */
	CCB				*last_hazard;
	int32				last_hazard_type;
	int32				current_row;
	int32				current_column;
	solid_object	*blocker;
	dude				*next;
};

/****************************************************************************************/

class seeker 
{
	private:
		anim_source		yellow_walk_e;
		anim_source		yellow_walk_n;
		anim_source		yellow_walk_w;
		anim_source		yellow_walk_s;
		anim_source		yellow_walk_sw;
		anim_source		yellow_walk_se;
		anim_source		yellow_walk_nw;
		anim_source		yellow_walk_ne;
		anim_source		yellow_pit_death;
		anim_source		yellow_lava_death;

		anim_source		ltblue_walk_e;
		anim_source		ltblue_walk_n;
		anim_source		ltblue_walk_w;
		anim_source		ltblue_walk_s;
		anim_source		ltblue_walk_sw;
		anim_source		ltblue_walk_se;
		anim_source		ltblue_walk_nw;
		anim_source		ltblue_walk_ne;
		anim_source	   ltblue_pit_death;
		anim_source	   ltblue_lava_death;

		anim_source		pink_walk_e;
		anim_source		pink_walk_n;
		anim_source		pink_walk_w;
		anim_source		pink_walk_s;
		anim_source		pink_walk_sw;
		anim_source		pink_walk_se;
		anim_source		pink_walk_nw;
		anim_source		pink_walk_ne;
		anim_source	   pink_pit_death;
		anim_source	   pink_lava_death;

		anim_source		lime_walk_e;
		anim_source		lime_walk_n;
		anim_source		lime_walk_w;
		anim_source		lime_walk_s;
		anim_source		lime_walk_sw;
		anim_source		lime_walk_se;
		anim_source		lime_walk_nw;
		anim_source		lime_walk_ne;
		anim_source	   lime_pit_death;
		anim_source	   lime_lava_death;
		anim_source	   lime_still;

		anim_source	   cham_wakeup_anim;
		anim_source	   redcoat_wakeup_anim;
		anim_source	   bummer_wakeup_anim;
		
		anim_source		zombie1_walk_e;
		anim_source		zombie1_walk_n;
		anim_source		zombie1_walk_w;
		anim_source		zombie1_walk_s;
		anim_source		zombie1_walk_sw;
		anim_source		zombie1_walk_se;
		anim_source		zombie1_walk_nw;
		anim_source		zombie1_walk_ne;
		anim_source		zombie2_walk_e;
		anim_source		zombie2_walk_n;
		anim_source		zombie2_walk_w;
		anim_source		zombie2_walk_s;
		anim_source		zombie2_walk_sw;
		anim_source		zombie2_walk_se;
		anim_source		zombie2_walk_nw;
		anim_source		zombie2_walk_ne;
		anim_source		zombie3_walk_e;
		anim_source		zombie3_walk_n;
		anim_source		zombie3_walk_w;
		anim_source		zombie3_walk_s;
		anim_source		zombie3_walk_sw;
		anim_source		zombie3_walk_se;
		anim_source		zombie3_walk_nw;
		anim_source		zombie3_walk_ne;
		anim_source	   zombie1pit_death;
		anim_source	   zombie2pit_death;
		anim_source	   zombie3pit_death;
		anim_source	   zombie1lava_death;
		anim_source	   zombie2lava_death;
		anim_source	   zombie3lava_death;
		anim_source    zombie_death;
		anim_source    zombie_shrapnel;
		anim_source	   zombie_birth;

		anim_source		lurker_walk_e;
		anim_source		lurker_walk_n;
		anim_source		lurker_walk_w;
		anim_source		lurker_walk_s;
		anim_source		lurker_walk_sw;
		anim_source		lurker_walk_se;
		anim_source		lurker_walk_nw;
		anim_source		lurker_walk_ne;
		anim_source	   lurker_pit_death;
		anim_source	   lurker_lava_death;
		anim_source	   lurker_wait;

		anim_source		meany_walk_e_w_n_s;
		anim_source		meany_walk_se_nw;
		anim_source		meany_walk_ne_sw;
		anim_source	   meany_pit_death;
		anim_source	   meany_lava_death;
		anim_source	   meany_split;
		anim_source		meany_stasis;
		anim_source		meany_split_n;
		anim_source		meany_split_s;
		anim_source		meany_split_e;
		anim_source		meany_split_w;

		anim_source		nasty_walk_e_w_n_s;
		anim_source		nasty_walk_se_nw;
		anim_source		nasty_walk_ne_sw;
		anim_source	   nasty_pit_death;
		anim_source	   nasty_lava_death;
		anim_source	   nasty_split;
		anim_source		nasty_stasis;
		anim_source		nasty_split_n;
		anim_source		nasty_split_s;
		anim_source		nasty_split_e;
		anim_source		nasty_split_w;

		anim_source		grumpy_walk_e_w_n_s;
		anim_source		grumpy_walk_se_nw;
		anim_source		grumpy_walk_ne_sw;
		anim_source	   grumpy_pit_death;
		anim_source	   grumpy_lava_death;
		
		anim_source		jugger_walk_e;
		anim_source		jugger_walk_n;
		anim_source		jugger_walk_w;
		anim_source		jugger_walk_s;
		anim_source		jugger_walk_sw;
		anim_source		jugger_walk_se;
		anim_source		jugger_walk_nw;
		anim_source		jugger_walk_ne;
		anim_source	   jugger_pit_death;
		anim_source	   jugger_lava_death;

		anim_source		psycho_walk_e;
		anim_source		psycho_walk_n;
		anim_source		psycho_walk_w;
		anim_source		psycho_walk_s;
		anim_source		psycho_walk_sw;
		anim_source		psycho_walk_se;
		anim_source		psycho_walk_nw;
		anim_source		psycho_walk_ne;
		anim_source	   psycho_pit_death;
		anim_source	   psycho_lava_death;
		anim_source	   psycho_unmoving;

		anim_source	   beam_in_part1;
		anim_source	   beam_in_part2;
		int32				grumpy_death_toll;

		void  			EliminateSeeker (dude *target);
		void 				ChangeDirection (dude *target, int32 new_direction);
		bool				StupidMovement (dude *target);
		bool				RiskyMovement (dude *target);
		bool				BrainyMovement (dude *target);
		void 				CommenceHazardDeath (dude *target);
		void				FollowHeading (CCB *target, int32 axis, int32 direction,
		                              int32 x_change, int32 y_change);
		bool 				TrapsLieAhead(dude *target);
		bool 				ChasingWildGeese (dude *target);
		bool				AtGoalEdge (dude *target, int32 axis, int32 direction, int32 old_x,
		                           int32 old_y);
		void 				HeadForTheDudemeyer (CCB *target,int32 horz_speed,int32 vert_speed);
		bool  			PullIntoHazard (dude *target);
		bool 				AvoidObstruction(dude *target,int32 old_x, int32 old_y,
												  int32 horz_speed, int32 vert_speed);
		bool 				RunAway (dude *target);
		void 				PlanObstacleDetour(dude *target,int32 x,int32 y);
		int32				PlanHazardDetour (dude *target, int32 dude_x, int32 dude_y);
		void  			DumpMovementStatus(dude *target);
		void 				SetSeekerSpeeds(dude *target);
		void 				DealWithSwamp(dude *target);
		void 				DealWithInvisibleFence (dude *target, int32 old_x, int32 old_y);
		bool				HandleNormalMove(dude *target,int32 old_x, int32 old_y);
		bool 				HandlePrimeDetourMove(dude *target,int32 old_x, int32 old_y);
		bool 				HandleAltDetourMove(dude *target,int32 old_x, int32 old_y);
		bool 				HandleHoudiniMove(dude *target,int32 old_x, int32 old_y);
		void  			CheckForCorruptedGrumpies();
		void 				ScottyEnergize(dude *target);

	public:
		CCB				*yellow_piece_cel;
		CCB				*pink_piece_cel;
		CCB				*ltblue_piece_cel;
		CCB				*lime_piece_cel;
		CCB				*lurker_piece_cel;
		anim_source    yellow_death;
		anim_source    ltblue_death;
		anim_source    pink_death;
		anim_source    lime_death_e;
		anim_source    lime_death_w;
		anim_source    lime_death_s;
		anim_source    lime_death_n;
		anim_source    cham_death_e;
		anim_source    cham_death_w;
		anim_source    cham_death_n;
		anim_source    cham_death_s;
		anim_source    lurker_death_e;
		anim_source    lurker_death_w;
		anim_source    lurker_death_s;
		anim_source    lurker_death_n;
		anim_source	   grumpy_death;
		anim_source	   jugger_death;
		anim_source	   psycho_death[3];
		anim_source    redcoat_death_e;
		anim_source    redcoat_death_w;
		anim_source    redcoat_death_n;
		anim_source    redcoat_death_s;
		anim_source    bummer_death;
		dude				*seeker_list;

		void  			BootSeekers (void);
		void  			LoadArtwork (int32 element_to_load);
		void  			InitializeSeekers (int32 level, int16 skill_level);		
		dude*  			CreateSeeker (int32 breed, int32 row, int32 column, int32 offset,
                                   bool homeward_bound);		
		void				SendHome (dude *target);
		void				SendHome (solid_object *target);
		int32 			GetSeekerHealth(solid_object *target, int32 &row, int32 &column);
		int32				DetermineDirection (dude *target, int32 old_x, int32 old_y);
		void				AnimateSeekers (int32 x_change, int32 y_change);
		bool				Obstructed (dude *target, bool ignore_rocks);
		bool  			CheckForSeekerHazardDeaths (void);
		solid_object*	CheckForSeekerCollisions (solid_object *target);
		bool 				CheckChameleonProximity(CCB *seeker_cel);
		void 				MaintainChameleon (dude *target);
		void 				ReviveZombie (dude *target);
		void 				ShootZombie(solid_object *target);
		void 				ShootSplitter(solid_object *target);
		bool 				TheCoastIsClear(dude *splitter,int32 direction,anim_source *new_anim,
												 int32 orig_x, int32 orig_y, int32 offset_x,
												 int32 offset_y, int32 new_col_detect_x,
												 int32 new_col_detect_y);
		void 				FinalSeparation (dude *mom, int32 new_type, int32 offset_x_a,
                                      int32 offset_y_a,int32 offset_x_b,int32 offset_y_b);
		void 				NurgeSplitter (dude *splitter);
		void 				MaintainSplitter (dude *splitter);
		bool				Loaded(int32 seeker_type);
		bool				StillMoving();
		int32 			CountSeekers();
		void  			ResetSeekers (void);
		void  			MoveBoredSeekersAround (void);
		void  			ShutdownForRestart (void);
		void  			ShutdownForExit (void);
		void  			ShutdownUnusedArtwork (void);
};

/***************************************** EOF ******************************************/
